<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblUsuarioRepository;

final class TblUsuarioService
{
    private TblUsuarioRepository $TblUsuarioRepository;

    public function __construct(TblUsuarioRepository $TblUsuarioRepository)
    {
        $this->TblUsuarioRepository = $TblUsuarioRepository;
    }

    public function checkAndGet(int $TblUsuarioId): object
    {
        return $this->TblUsuarioRepository->checkAndGet($TblUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblUsuarioRepository->getAll();
    }

    public function getOne(int $TblUsuarioId): object
    {
        return $this->checkAndGet($TblUsuarioId);
    }

    public function create(array $input): object
    {
        $TblUsuario = json_decode((string) json_encode($input), false);

        return $this->TblUsuarioRepository->create($TblUsuario);
    }

    public function update(array $input, int $TblUsuarioId): object
    {
        $TblUsuario = $this->checkAndGet($TblUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblUsuarioRepository->update($TblUsuario, $data);
    }

    public function delete(int $TblUsuarioId): void
    {
        $this->checkAndGet($TblUsuarioId);
        $this->TblUsuarioRepository->delete($TblUsuarioId);
    }
}
